;; -*- lexical-binding: t; -*-

(eval-after-load 'w3m
  (defun elmord-w3m-eval-after-load ()
    (define-key w3m-mode-map (kbd "C-<prior>") 'w3m-previous-buffer)
    (define-key w3m-mode-map (kbd "C-<next>") 'w3m-next-buffer)
    (define-key w3m-mode-map (kbd "C-c RET") 'w3m-view-this-url-new-session)
    (define-key w3m-mode-map (kbd "<up>") 'previous-line)
    (define-key w3m-mode-map (kbd "<down>") 'next-line)
    (define-key w3m-mode-map (kbd "<left>") 'backward-char)
    (define-key w3m-mode-map (kbd "<right>") 'backward-char)
    (define-key w3m-mode-map (kbd "C-w") 'w3m-delete-buffer)
    ))

(eval-after-load 'w3m-search
  (defun elmord-w3m-search-eval-after-load ()
    (add-to-list 'w3m-search-engine-alist
                 '("duckduckgo"
                   "https://duckduckgo.com/lite/q=%s"
                   utf-8))
    (setq w3m-search-default-engine "duckduckgo")))

(eval-after-load 'w3m-filter
  (defun elmord-w3m-filter-eval-after-load ()
    (add-to-list 'w3m-filter-configuration
      '(t "Folha" "\\`https://[^/]*\\.folha\\.uol\\.com\\.br/" elmord-w3m-filter-folha))))

(add-hook 'w3m-mode-hook
  (defun elmord-w3m-mode-hook ()
    (setq-local line-spacing 0.5)))

(defun elmord-w3m-filter-folha (&optional url)
  (w3m-filter-delete-regions url "<button" ">"))

;; Don't use proportional fonts in Elfeed (which uses shr).
(setq shr-use-fonts nil)

(setq w3m-clear-display-while-reading nil)
(setq w3m-fill-column 80)
