#!/bin/bash

find_virtualenv_root() {
    (
        while :; do
            if [[ "$PWD" = / ]]; then
                return 1
            elif [[ -e .venv ]]; then
                echo "$PWD"
                return 0
            else
                cd ..
            fi
        done
    )
}

export PROJECT_ROOT="$(find_virtualenv_root)" || {
    echo "Could not determine virtualenv root." >&2
    exit 1
}

export MYPYPATH="$PROJECT_ROOT"

source "$PROJECT_ROOT/.venv/bin/activate"
[[ -f "$PROJECT_ROOT/environment.sh" ]] && source "$PROJECT_ROOT/environment.sh"

true
